unit GpSmartControls;

interface

uses w3system, w3ctrls;

type
  TW3ImageButton = class(TW3Button)
  private
    FCaption: string;
    FImage: string;
  protected
    procedure SetCaption(const value: string);
    procedure SetImage(const value: string);
    procedure SetInnerHtml;
    procedure StyleTagObject; override;
  public
    property Caption: string read FCaption write SetCaption;
    property Image: string read FImage write SetImage;
  end;

  procedure SetButtonImage(button: TW3Button; const image: string);

implementation

uses
  w3regex;

procedure SetButtonImage(button: TW3Button; const image: string);
var
  hText: string;
begin
  hText := TW3RegEx.Replace(button.InnerHTML, '', '\<img.*?\>');
  if image <> '' then
    hText := hText
      + '<img valign="middle" align="middle" alt=""'
      + 'src="data:image/png;base64,' + image + '" />';
  button.InnerHTML := hText;
end;

{ TW3ImageButton }

procedure TW3ImageButton.SetCaption(const value: string);
begin
  if FCaption <> value then begin
    FCaption := value;
    SetInnerHtml;
  end;
end;

procedure TW3ImageButton.SetImage(const value: string);
begin
  if FImage <> value then begin
    FImage := value;
    SetInnerHtml;
  end;
end;

procedure TW3ImageButton.SetInnerHtml;
begin
  SetButtonImage(Self, FImage);
end;

procedure TW3ImageButton.StyleTagObject;
begin
  inherited;
  StyleClass := 'TW3Button';
end;

end.
